/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "cytypes.h"
#include "cyfitter.h"

#ifndef stepper_1_H
#define stepper_1_H

#define stepper_1_POS_PER_REV 36000

//Initialize local values with defaults.
int stepper_1_stepsPerRev = 200;
int stepper_1_currentPos = 0;    //In 1/100ths of a degree.
uint8 stepper_1_stepSize = 1;    //Possible values: 1, 2, 4, 8, 16
uint16 stepper_1_stepTime = 1200;    //Time in ms required between steps.
int stepper_1_conversion = (360*100)/(200*1);  // 1/100ths of a degree per step

//Sets up the part
void stepper_1_start();
    
//Determines what direction and the distance to a desired location. (desired is in 1/100th of a degree.)
int stepper_1_desiredToRelative(int desired);

//Takes a step of the default size toward a desired position. (desired is in 1/100th of a degree.)
void stepper_1_stepTowardDesired(int desired);

//Take a single step of the default size
void stepper_1_step();

//Set the default step size. Can be changed at any time. 1 = full step, 2 = half, etc.
void stepper_1_setStepSize(uint8 stepMode);

//Set the current rotation direction. 1 is CW, 0 is CCW.
void stepper_1_setDirection(uint8 direction);

//Set the min time between steps
void stepper_1_setStepTime(uint16 time);

//Set the current position.
void stepper_1_setPos(int pos);

//Set how many steps per rev. the motor has.
void stepper_1_setStepsPerRev(int steps);

//Update the conversion factor
void stepper_1_updateConversion();


#endif

//[] END OF FILE
