/*******************************************************************************
* File Name: stepper_1_Clock_1.h
* Version 2.0
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_stepper_1_Clock_1_H)
#define CY_CLOCK_stepper_1_Clock_1_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/

void stepper_1_Clock_1_Start(void);
void stepper_1_Clock_1_Stop(void);

void stepper_1_Clock_1_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 stepper_1_Clock_1_GetDividerRegister(void);
uint8  stepper_1_Clock_1_GetFractionalDividerRegister(void);

#define stepper_1_Clock_1_Enable()                         stepper_1_Clock_1_Start()
#define stepper_1_Clock_1_Disable()                        stepper_1_Clock_1_Stop()
#define stepper_1_Clock_1_SetDividerRegister(clkDivider, reset)  \
                        stepper_1_Clock_1_SetFractionalDividerRegister((clkDivider), 0)
#define stepper_1_Clock_1_SetDivider(clkDivider)           stepper_1_Clock_1_SetDividerRegister((clkDivider), 1)
#define stepper_1_Clock_1_SetDividerValue(clkDivider)      stepper_1_Clock_1_SetDividerRegister((clkDivider) - 1, 1)


/***************************************
*             Registers
***************************************/

#define stepper_1_Clock_1_DIV_REG    (*(reg32 *)stepper_1_Clock_1__REGISTER)
#define stepper_1_Clock_1_ENABLE_REG stepper_1_Clock_1_DIV_REG

#endif /* !defined(CY_CLOCK_stepper_1_Clock_1_H) */

/* [] END OF FILE */
