/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "`$INSTANCE_NAME`.h"
#include "device.h"

void `$INSTANCE_NAME`_start()
{
    `$INSTANCE_NAME`_Counter_Start();
}

//Determines what direction and the distance to a desired location.
int `$INSTANCE_NAME`_desiredToRelative(int desired)
{
    int relative = 0;
    
    //Determine what direction we need to go.
    int distance = `$INSTANCE_NAME`_currentPos + `$INSTANCE_NAME`_POS_PER_REV - desired;
    if(distance < (`$INSTANCE_NAME`_POS_PER_REV/2))
        relative = -1;
    else
        relative = 1;
    
    relative *= distance;
    
    return relative;
}

//Takes a step of the default size toward a desired position.
void `$INSTANCE_NAME`_stepTowardDesired(int desired)
{
    int relative = `$INSTANCE_NAME`_desiredToRelative(desired);
    
    if(relative > 0)    //Should probably have protection for very small offsets, smaller than possible step.
    {
        `$INSTANCE_NAME`_setDirection(1);
        //Can add code here to take bigger steps if farther from desired location.
        `$INSTANCE_NAME`_step();
    }
    else if (relative < 0)
    {
        `$INSTANCE_NAME`_setDirection(0);
        //Can add code here to take bigger steps if farther from desired location.
        `$INSTANCE_NAME`_step();
    }
    
}

//Take a single step of the default size
void `$INSTANCE_NAME`_step()
{
    if(`$INSTANCE_NAME`_counterStatus_Read())
    {
        uint8 val = `$INSTANCE_NAME`_outputs_Read();    //Get current register value
        val = (val | 0b01000);                          //Set bit 3 high.
        `$INSTANCE_NAME`_outputs_Write(val);            //Write the new value to the register
        CyDelayUs(1);                                   //Wait long enough for the sensor driver.
        val = val & 0b10111;                            //Set the bit low again
        `$INSTANCE_NAME`_outputs_Write(val);            //Write
        
        `$INSTANCE_NAME`_resetCounter_Write(1);         //Reset the step wait counter.
        
        if(`$INSTANCE_NAME`_outputs_Read() & 0b10000)
            `$INSTANCE_NAME`_currentPos += 1;   //This isn't actually correct, since the pos is in 1/100 of a degree.
        else
            `$INSTANCE_NAME`_currentPos -= 1;
    }
}

//Set the default step size. Can be changed at any time.
//See A4988 stepper driver datasheet for more details
void `$INSTANCE_NAME`_setStepSize(uint8 stepMode)
{
    if(stepMode == 1)
    {
         uint8 val= `$INSTANCE_NAME`_outputs_Read();
         val = val & 0b11000;                         //Set MS1, MS2, MS3 low.
        `$INSTANCE_NAME`_outputs_Write(val);
        
        `$INSTANCE_NAME`_stepSize = stepMode;
        `$INSTANCE_NAME`_updateConversion();
    }
    else if(stepMode == 2)
    {
         uint8 val= `$INSTANCE_NAME`_outputs_Read();
         val = val & 0b11000;                         //Set MS1, MS2, MS3 low.
         val = val | 0b00001;                         //Set MS1 high.
        `$INSTANCE_NAME`_outputs_Write(val);
        
        `$INSTANCE_NAME`_stepSize = stepMode;
        `$INSTANCE_NAME`_updateConversion();
    }
    else if(stepMode == 4)
    {
         uint8 val= `$INSTANCE_NAME`_outputs_Read();
         val = val & 0b11000;                         //Set MS1, MS2, MS3 low.
         val = val | 0b00010;                         //Set MS2 high.
        `$INSTANCE_NAME`_outputs_Write(val);
        
        `$INSTANCE_NAME`_stepSize = stepMode;
        `$INSTANCE_NAME`_updateConversion();
    }
    else if(stepMode == 8)
    {
         uint8 val= `$INSTANCE_NAME`_outputs_Read();
         val = val & 0b11000;                         //Set MS1, MS2, MS3 low.
         val = val | 0b00011;                         //Set MS1 and MS2 high.
        `$INSTANCE_NAME`_outputs_Write(val);
        
        `$INSTANCE_NAME`_stepSize = stepMode;
        `$INSTANCE_NAME`_updateConversion();
    }
    else if(stepMode == 16)
    {
         uint8 val= `$INSTANCE_NAME`_outputs_Read();
         val = val | 0b00111;                         //Set MS1, MS2, MS3 high.
        `$INSTANCE_NAME`_outputs_Write(val);
        
        `$INSTANCE_NAME`_stepSize = stepMode;
        `$INSTANCE_NAME`_updateConversion();
    }

}

//Set the current rotation direction. 1 is CW, 0 is CCW
void `$INSTANCE_NAME`_setDirection(uint8 direction)
{
    if(direction)
    {
        uint8 val= `$INSTANCE_NAME`_outputs_Read();
         val = val | 0b10000;                         //Set DIR high.
        `$INSTANCE_NAME`_outputs_Write(val);
    }
    else
    {
         uint8 val= `$INSTANCE_NAME`_outputs_Read();
         val = val & 0b01111;                         //Set DIR low.
        `$INSTANCE_NAME`_outputs_Write(val);
    }
    
}

//Set the min time between steps
void `$INSTANCE_NAME`_setStepTime(uint16 time)
{
    `$INSTANCE_NAME`_stepTime = time;
    `$INSTANCE_NAME`_Counter_WritePeriod(`$INSTANCE_NAME`_stepTime);
}

//Set the current position.
void `$INSTANCE_NAME`_setPos(int pos)
{
    `$INSTANCE_NAME`_currentPos = pos;
}

//Set how many steps per rev. the motor has.
void `$INSTANCE_NAME`_setStepsPerRev(int steps)
{
    `$INSTANCE_NAME`_stepsPerRev = steps;
    `$INSTANCE_NAME`_updateConversion();
}

//Update the conversion factor
void `$INSTANCE_NAME`_updateConversion()
{
    `$INSTANCE_NAME`_conversion = (360*100)/(`$INSTANCE_NAME`_stepsPerRev*`$INSTANCE_NAME`_stepSize);
}


/* [] END OF FILE */
