/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "cytypes.h"
#include "cyfitter.h"

#ifndef `$INSTANCE_NAME`_H
#define `$INSTANCE_NAME`_H

#define `$INSTANCE_NAME`_POS_PER_REV 36000

//Initialize local values with defaults.
int `$INSTANCE_NAME`_stepsPerRev = 200;
int `$INSTANCE_NAME`_currentPos = 0;    //In 1/100ths of a degree.
uint8 `$INSTANCE_NAME`_stepSize = 1;    //Possible values: 1, 2, 4, 8, 16
uint16 `$INSTANCE_NAME`_stepTime = 1200;    //Time in ms required between steps.
int `$INSTANCE_NAME`_conversion = (360*100)/(200*1);  // 1/100ths of a degree per step

//Sets up the part
void `$INSTANCE_NAME`_start();
    
//Determines what direction and the distance to a desired location. (desired is in 1/100th of a degree.)
int `$INSTANCE_NAME`_desiredToRelative(int desired);

//Takes a step of the default size toward a desired position. (desired is in 1/100th of a degree.)
void `$INSTANCE_NAME`_stepTowardDesired(int desired);

//Take a single step of the default size
void `$INSTANCE_NAME`_step();

//Set the default step size. Can be changed at any time. 1 = full step, 2 = half, etc.
void `$INSTANCE_NAME`_setStepSize(uint8 stepMode);

//Set the current rotation direction. 1 is CW, 0 is CCW.
void `$INSTANCE_NAME`_setDirection(uint8 direction);

//Set the min time between steps
void `$INSTANCE_NAME`_setStepTime(uint16 time);

//Set the current position.
void `$INSTANCE_NAME`_setPos(int pos);

//Set how many steps per rev. the motor has.
void `$INSTANCE_NAME`_setStepsPerRev(int steps);

//Update the conversion factor
void `$INSTANCE_NAME`_updateConversion();


#endif

//[] END OF FILE
